<template>
    <div class="Carcass">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">胴体销售</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getCarcassList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="salesNo" label="销售单号" width="100"></el-table-column>

                    <el-table-column prop="carcassCode" label="胴体编码" width="100"></el-table-column>
                    <el-table-column prop="sellingTime" label="出售时间" width="180"></el-table-column>
                    <el-table-column prop="slaughterBatch" label="批次号"></el-table-column>
                    <el-table-column prop="carcassWeight" label="胴体重量(kg)"></el-table-column>

                    <el-table-column prop="saleAmount" label="销售金额(元)"></el-table-column>

                    <el-table-column prop="buyer" label="购买人(企业)"></el-table-column>
                    <el-table-column prop="seller" label="经办人"></el-table-column>
                    <el-table-column prop="transportNo" label="运输单号"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addCarcass" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="销售单号">
                            <el-input v-model="formData.salesNo"></el-input>
                        </el-form-item>

                        <el-form-item label="胴体编码">
                            <el-input v-model="formData.carcassCode"></el-input>
                        </el-form-item>

                        <el-form-item label="出售时间">
                            <el-date-picker
                                v-model="formData.sellingTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="批次号">
                            <el-input v-model="formData.slaughterBatch"></el-input>
                        </el-form-item>

                        <el-form-item label="胴体重量(kg)">
                            <el-input v-model="formData.carcassWeight"></el-input>
                        </el-form-item>

                         <el-form-item label="销售金额(元)">
                            <el-input v-model="formData.saleAmount"></el-input>
                        </el-form-item>

                        <el-form-item label="购买人(企业)">
                            <el-input v-model="formData.buyer"></el-input>
                        </el-form-item>

                        <el-form-item label="经办人">
                            <el-input v-model="formData.seller"></el-input>
                        </el-form-item>

                        <el-form-item label="运输单号">
                            <el-input v-model="formData.transportNo"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addCarcass')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqCarcassList,
    reqAddCarcass,
    reqUpdateCarcass,
    reqDelCarcass
} from "@/api/sellManagement.js";

const pageSize = 10;
const rules = {};

export default {
    name: "Carcass",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                salesNo: "JD5S6D4F444",
                carcassCode: "1688",
                sellingTime: this.$moment().format("YYYY-MM-DD"),
                slaughterBatch: "58715",
                carcassWeight: "26",
                saleAmount: "26789.5",
                buyer: "张小刚",
                seller: "李思涵",
                transportNo: "DS74V5DDF5455"
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 出仓管理列表
        this.getCarcassList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddCarcass(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getCarcassList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateCarcass(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getCarcassList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 出仓管理列表 
        getCarcassList() {
            reqCarcassList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false
        },
        del(row) {
            reqDelCarcass(row.id)
                .then(res => {
                    console.log(res);
                    // 出仓管理列表
                    this.getCarcassList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 出仓管理列表
            this.getCarcassList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>